<?php
	header("HTTP/1.1 403 Forbidden");
?>
<!DOCTYPE html>
<html lang="en" class="no-js" xmlns:og="https://ogp.me/ns#">
<head>
	<meta charset="UTF-8" />
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<meta name="theme-color" content="#ff89c9">
	<title>Imeji Uploader - Error</title>
	<link rel="shortcut icon" href="https://zxicar.us/favicon.ico">
	<link rel="icon" type="image/png" href="https://zxicar.us/favicon-32x32.png" sizes="32x32" />
	<link rel="icon" type="image/png" href="https://zxicar.us/favicon-16x16.png" sizes="16x16" />
	<link rel="apple-touch-icon-precomposed" sizes="57x57" href="https://zxicar.us/apple-touch-icon-57x57.png" />
	<link rel="apple-touch-icon-precomposed" sizes="114x114" href="https://zxicar.us/apple-touch-icon-114x114.png" />
	<link rel="apple-touch-icon-precomposed" sizes="72x72" href="https://zxicar.us/apple-touch-icon-72x72.png" />
	<link rel="apple-touch-icon-precomposed" sizes="144x144" href="https://zxicar.us/apple-touch-icon-144x144.png" />
	<link rel="apple-touch-icon-precomposed" sizes="120x120" href="https://zxicar.us/apple-touch-icon-120x120.png" />
	<link rel="apple-touch-icon-precomposed" sizes="152x152" href="https://zxicar.us/apple-touch-icon-152x152.png" />
	<meta name="application-name" content="I.C.A.R.U.S."/>
	<meta name="msapplication-TileColor" content="#FFFFFF" />
	<meta name="msapplication-TileImage" content="https://zxicar.us/mstile-144x144.png" />
	<meta property="og:description" content="Access Denied - You do not have authorization to access the requested file." />
	
	<link rel="stylesheet" type="text/css" href="https://zxicar.us/imeji/styler/normalize.css" />
	<link rel="stylesheet" type="text/css" href="https://zxicar.us/imeji/styler/demo.css" />
	<link rel="stylesheet" type="text/css" href="https://zxicar.us/imeji/styler/component.css" />
	<link rel="stylesheet" type="text/css" href="https://zxicar.us/imeji/styler/additional.css" />
	<!--[if IE]>
	<script src="https://html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	
	<!-- remove this if you use Modernizr -->
	<script>(function(e,t,n){var r=e.querySelectorAll("html")[0];r.className=r.className.replace(/(^|\s)no-js(\s|$)/,"$1js$2")})(document,window,0);</script>
</head>
<body>
	<div class="container">
		<header class="codrops-header">
			<h1>I.C.A.R.U.S. Imeji Uploader</h1>
			<p><strong>403</strong> - Unfortunately the file you are looking for isn't something you can access.</p>
		</header>
	</div><!-- /container -->

	<!-- <script src="styler/custom-file-input.js"></script> -->

	<!-- // If you'd like to use jQuery, check out styler/jquery.custom-file-input.js
	<script src="styler/jquery-v1.min.js"></script>
	<script src="styler/jquery.custom-file-input.js"></script>
	-->

	<div class="content">
		<hr />
		<footer class="content footer">
			Copyright &copy; 2016 Locaria Technologies.
		</footer>
	</div>

</body>
</html>